<form class="{{cssClass}} updatedNPCSheet" autocomplete="off">
    <div class="contentcontainer">

        <div class="npc-title-bar">
            <h1 class="name">{{actor.name}}</h1>
            <h1 class="editNPCButton">
                <label>{{localize "PF2E.EditNPCLabel"}}</label>
                <input class="isNPCEditable" name="flags.pf2e.editNPC.value" type="checkbox" data-dtype="Boolean" {{checked flags.pf2e.editNPC.value}} />
            </h1>
            <h1 class="creature-adjustment traits-bar" style="font-size: 1em;font-weight: normal;">
                <a class="npc-elite-adjustment trait{{npcEliteActive}}{{npcEliteHidden}}">ELITE</a>
                <a class="npc-weak-adjustment trait{{npcWeakActive}}{{npcWeakHidden}}">WEAK</a>
            </h1>
            <h1 class="level">{{localize "PF2E.NPC.Creature"}} {{data.details.level.value}}</h1>
        </div>

    <div class="top-section">

      <div class="top-quick-container">

        <span class="hp-current" title="{{localize "PF2E.MaxHitPointsShortLabel"}}: {{data.attributes.hp.max}}">
          <label>{{localize "PF2E.CurrentHitPointsShortLabel"}}:</label>
          <input name="data.attributes.hp.value" type="number" value="{{data.attributes.hp.value}}" data-dtype="Number" placeholder="0">
        </span>
        <div class="stats-line">
          <span class="inline-stats">
            <label class="stat-title attribute-name">{{localize "PF2E.AttitudeLabel"}}</label>
            <span class="stat-value attribute-name">{{localize actorAttitude}}</span>
          </span>
        </div>
        <label>{{localize "PF2E.NPCNotesLabel"}}:</label>
        <textarea name="flags.pf2e_updatednpcsheet.npcNotes.value" type="text" data-dtype="String" placeholder="{{localize "PF2E.NPCNotesTitle"}}">{{flags.pf2e_updatednpcsheet.npcNotes.value}}</textarea>
      </div>

      <div class="top-stats-container">

        <div class="traits-bar">
          <!-- -->
          <!-- Put alignment flag here; add to getData() -->
          {{#if isNotCommon}}
          <span class="trait {{data.traits.rarity.value}}">{{localize actorRarity}}</span>
          {{/if}}
          <span class="trait alignment">{{actorAlignment}}</span>
          <span class="trait size">{{localize actorSize}}</span>
          <!-- Put Trait #each here-->
          {{#each actor.data.traits.traits.selected as |trait id|}}
              <span class="trait">{{localize trait}}</span>
          {{/each}}
        </div>

        <div class="stats-line recall-knowledge">
          <span class="inline-stats">
            <label class="stat-title attribute-name">{{localize "PF2E.RecallKnowledge.Label"}}</label>
            {{#if identificationSkills}}
                <span class="stat-list" title="{{identifySkillProgression}}">
                    <span class="stat-minortitle">
                        <ul class="skill-list">
                            {{#each identificationSkills as |skill|}}
                                <li>{{localize skill}}</li>
                            {{/each}}
                        </ul>
                    </span>
                    <span class="stat-value">{{identifySkillDC}} ({{localize identifySkillAdjustment}})</span>
                </span>
            {{/if}}
            <span class="stat-list" title="{{unspecificLoreProgression}}">
              <span class="stat-minortitle">{{localize "PF2E.RecallKnowledge.UnspecificLore"}}</span>
              <span class="stat-value">{{unspecificLoreDC}} ({{localize unspecificLoreAdjustment}})</span>
            </span>
            <span class="stat-list" title="{{specificLoreProgression}}">
              <span class="stat-minortitle">{{localize "PF2E.RecallKnowledge.SpecificLore"}}</span>
              <span class="stat-value">{{specificLoreDC}} ({{localize specificLoreAdjustment}})</span>
            </span>
            <button class="recall-knowledge-breakdown">{{localize "PF2E.RecallKnowledge.Breakdown"}}</button>
          </span>
        </div>

        <div class="stats-line">
          <span class="inline-stats rollable" data-attribute="perception" title="{{data.attributes.perception.breakdown}}">
            <label class="stat-title attribute-name">{{localize "PF2E.PerceptionLabel"}}</label>
            <span class="stat-value attribute-name">{{numberFormat data.attributes.perception.value decimals=0 sign=true}}</span>
            <span class="stat-detail perception attribute-name">{{data.traits.senses.value}}</span>
          </span>
        </div>

        {{#if hasLanguages}}
        <div class="stats-line">
          <span class="inline-stats">
            <label class="stat-title">{{localize "PF2E.Languages"}}</label>
            {{#each actor.data.traits.languages.selected as |lang lid|}}
            <span class="stat-list">
              <span class="stat-minortitle">{{localize lang}}</span>
            </span>
            {{/each}}
          </span>
        </div>
        {{/if}}

        {{#if hasSkills}}
        <div class="stats-line">
          <span class="inline-stats">
            <label class="stat-title">{{localize "PF2E.SkillsLabel"}}</label>
            {{#each actor.data.skills as |skill shortform|}}
            {{#if skill.visible}}
            <span class="stat-list">
              <span class="list-row rollable" data-skill="{{shortform}}" title="{{skill.breakdown}}">
                <span class="stat-minortitle npc-skill-name rollable">{{skill.name}}</span>
                <span class="stat-value npc-skill-name rollable">{{numberFormat skill.value decimals=0 sign=true}}</span>
              </span>
              {{#if skill.variants}}
              <span class="skill-variants">(
              {{#each skill.variants}}
                <span class="list-row rollable" data-skill="{{shortform}}" data-options="{{this.options}}">
                  <span class="npc-skill-name rollable">{{this.label}}</span>
                </span>
              {{/each}}
              )</span>
              {{/if}}
            </span>
            {{/if}}
            {{/each}}
          </span>
        </div>
        {{/if}}

        <div class="stats-line">
          <span class="inline-stats">
            {{#each data.abilities as |ability id|}}
            <span class="stat-list rollable" data-ability="{{id}}">
              <label class="stat-title ability-name">{{id}}</label>
              <span class="stat-value ability-name">{{numberFormat ability.mod decimals=0 sign=true}}</span>
            </span>
            {{/each}}
          </span>
        </div>

        {{#if hasEquipment}}
            <div class="stats-line equipment item-list">
                <span class="inline-stats">
                    <label class="stat-title">{{localize "PF2E.ItemsLabel"}}</label>
                    {{#each actor.equipment as |item iid|}}
                        <span class="stat-list item" data-item-id="{{item._id}}">
                            <span class="stat-minortitle item-control item-edit" data-item-id="{{item._id}}" title="{{strip_tags item.data.description.value}}">
                                {{item.name}}
                                {{#if (and @root.user.isGM (not item.isIdentified))}}<span class="gm-mystified-data">({{item.data.identification.identified.name}})</span>{{/if}}
                            </span>
                        </span>
                    {{/each}}
                </span>
            </div>
        {{/if}}

      </div>
    </div>

    <hr>

    <ol class="actions-list inventory-list directory-list item-list">
      {{#each actor.reorgActions.interaction.actions as |section sid|}}
        {{#each section.actions as |action aid|}}
        <li class="list-row item action-item" data-item-name="{{action.name}}" data-item-id="{{action._id}}">
            <div class="item-name rollable">
                <div class="item-image" style="background-image: url({{action.img}})"></div>
                <h4>{{action.name}}</h4>
            </div>
            {{#if @root.owner}}
            <div class="item-controls">
                <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>
            </div>
            {{/if}}
        </li>
        {{/each}}
     {{/each}}
    </ol>

    <hr>

    <div class="stats-line">
      <span class="inline-stats">
        <span class="stat-list major-stat" title="{{data.attributes.ac.breakdown}}">
          <label class="stat-title">{{localize "PF2E.ArmorClassShortLabel"}}</label>
          <span class="stat-value">{{numberFormat data.attributes.ac.value decimals=0}}</span>
          {{#if hasACDetails}}
          <span class="stat-detail">{{data.attributes.ac.details}}</span>
          {{/if}}
        </span>
        <span class="stat-list rollable" data-save="fortitude" title="{{data.saves.fortitude.breakdown}}">
          <label class="stat-title save-name">{{localize "PF2E.SavesFortitudeShort"}}</label>
          <span class="stat-value save-name">{{numberFormat data.saves.fortitude.value decimals=0 sign=true}}</span>
          {{#if hasFortDetails}}
          <span class="stat-detail save-name">{{data.saves.fortitude.saveDetail}}</span>
          {{/if}}
        </span>
        <span class="stat-list rollable" data-save="reflex" title="{{data.saves.reflex.breakdown}}">
          <label class="stat-title save-name">{{localize "PF2E.SavesReflexShort"}}</label>
          <span class="stat-value save-name">{{numberFormat data.saves.reflex.value decimals=0 sign=true}}</span>
          {{#if hasRefDetails}}
          <span class="stat-detail save-name">{{data.saves.reflex.saveDetail}}</span>
          {{/if}}
        </span>
        <span class="stat-list rollable" data-save="will" title="{{data.saves.will.breakdown}}">
          <label class="stat-title save-name">{{localize "PF2E.SavesWillShort"}}</label>
          <span class="stat-value save-name">{{numberFormat data.saves.will.value decimals=0 sign=true}}</span>
          {{#if hasWillDetails}}
          <span class="stat-detail save-name">{{data.saves.will.saveDetail}}</span>
          {{/if}}
        </span>
        {{#if hasAllSaveDetails}}
        <span class="stat-list" data-save="will">
          <label class="stat-title">{{localize "PF2E.AllSavesLabel"}}</label>
          <span class="stat-value">{{data.attributes.allSaves.value}}</span>
        </span>
        {{/if}}

      </span>
    </div>

    <div class="stats-line">
      <span class="inline-stats">
        <span class="stat-list major-stat" title="{{data.attributes.hp.breakdown}}">
          <label class="stat-title">{{localize "PF2E.HitPointsShortLabel"}}</label>
          <span class="stat-value">{{data.attributes.hp.max}}</span>
          {{#if hasHPDetails}}
          <span class="stat-detail">{{data.attributes.hp.details}}</span>
          {{/if}}
        </span>

        {{#if hasImmunities}}
        <span class="stat-list major-stat">
          <label class="stat-title">{{localize "PF2E.ImmunitiesLabel"}}</label>
          {{#each data.traits.di.selected as |trait id|}}
            <span class="stat-value">{{localize trait}}</span>
          {{/each}}
        </span>
        {{/if}}

        {{#if hasResistances}}
        <span class="stat-list major-stat">
          <label class="stat-title">{{localize "PF2E.ResistancesLabel"}}</label>
          {{#each data.traits.dr as |trait id|}}
            <span class="stat-value">{{trait.label}}: {{trait.value}}{{#if trait.exceptions}} ({{trait.exceptions}}){{/if}}</span>
          {{/each}}
        </span>
        {{/if}}

        {{#if hasWeaknesses}}
        <span class="stat-list major-stat">
          <label class="stat-title">{{localize "PF2E.WeaknessesLabel"}}</label>
          {{#each data.traits.dv as |trait id|}}
            <span class="stat-value">{{trait.label}}: {{trait.value}}</span>
          {{/each}}
        </span>
        {{/if}}

      </span>
    </div>

    <ol class="actions-list inventory-list directory-list item-list">
      {{#each actor.reorgActions.defensive.actions as |section sid|}}
        {{#each section.actions as |action aid|}}
        <li class="list-row item action-item" data-item-name="{{action.name}}" data-item-id="{{action._id}}">
            <div class="item-name rollable">
                <div class="item-image" style="background-image: url({{action.img}})"></div>
                <h4>{{action.name}}</h4>
                <div class="melee-buttons">
                {{#if action.traits}}
                  {{#each action.traits as |trait tid|}}
                    {{#if trait.description}}
                      <span class="tag-legacy" title="{{localize trait.description}}" style="padding: 0 3px;">{{localize trait.label}}</span>
                    {{else}}
                      <span class="tag-legacy" style="padding: 0 3px;">{{localize trait.label}}</span>
                    {{/if}}
                  {{/each}}
                {{/if}}
                </div>
            </div>
        </li>
        {{/each}}
     {{/each}}
    </ol>

    <hr>

    <div class="stats-line">
      <span class="inline-stats">
          <label class="stat-title">{{localize "PF2E.Speed"}}</label>
          <span class="stat-value">{{data.attributes.speed.value}}</span>
          {{#if hasSpeedDetails}}
          {{#each hasSpeedDetails as |speed id|}}
            <span class="stat-detail speed">{{speed.type}}: {{speed.value}}</span>
          {{/each}}
          {{/if}}
      </span>
    </div>

    <ol class="actions-list inventory-list directory-list item-list">
      {{#each actor.attacks as |section sid|}}
        <li class="list-row inventory-header sub-category spellbook-header attack-header">
            <h3 class="item-name pf-sub-category pf-actions">{{section.label}}</h3>
            {{#if ../owner}}
            <div class="item-controls">
                <a class="item-control item-create" title="{{localize "PF2E.CreateAttackTitle"}}" data-type="{{section.type}}" data-action-type="{{sid}}"><i class="fas fa-plus"></i>{{localize "PF2E.AddShortLabel"}}</a>
            </div>
            {{/if}}
        </li>
        {{#each section.items as |item iid|}}
        <li class="list-row item" data-item-id="{{item._id}}">
            <div class="melee-name rollable">
                <div class="item-image" style="background-image: url({{item.img}})"></div>
                <h4>
                  {{localize section.prefix}}
                  <span class="strike">{{item.name}}</span>
                </h4>
                <div class="melee-buttons">
                    {{#if item.traits}}
                        {{#each item.traits as |trait tid|}}
                            {{#if trait.description}}
                                <span class="tag-legacy" title="{{localize trait.description}}" style="padding: 0 3px;">{{localize trait.label}}</span>
                            {{else}}
                                <span class="tag-legacy" style="padding: 0 3px;">{{localize trait.label}}</span>
                            {{/if}}
                        {{/each}}
                    {{/if}}
                    <span class="tag-legacy">
                        <button data-action="legacy-attack">{{localize "PF2E.WeaponStrikeLabel"}} (+
                            {{#if @root.notAdjusted}}
                                {{item.data.bonus.total}}
                            {{else}}
                                {{#if @root.npcEliteActive}}{{add item.data.bonus.total 2}}{{/if}}
                                {{#if @root.npcWeakActive}}{{add item.data.bonus.total -2}}{{/if}}
                            {{/if}}
                            )
                        </button>
                    </span>
                    <span class="tag-legacy"><button data-action="legacy-attack-2">{{#unless item.data.isAgile}}-5{{else}}-4{{/unless}}</button></span>
                    <span class="tag-legacy"><button data-action="legacy-attack-3">{{#unless item.data.isAgile}}-10{{else}}-8{{/unless}}</button></span>
                    <span class="tag-legacy">
                        <button data-action="legacy-damage">
                            {{localize "PF2E.DamageLabel"}} (
                            {{#if item.data.damageRolls}}
                                {{#each item.data.damageRolls as |dmg index|}}
                                    {{dmg.damage}}{{#if @first}}{{#if @root.npcEliteActive}}+2{{/if}}{{#if @root.npcWeakActive}}-2{{/if}}{{/if}} {{dmg.damageType}}
                                {{/each}}
                            {{/if}}
                            )
                        </button>
                    </span>
                    <span class="tag-legacy"><button data-action="legacy-critical">{{localize "PF2E.CriticalDamageLabel"}}</button></span>
                    {{#if_all item.data item.data.attackEffects item.data.attackEffects.value}}
                        {{#each item.data.attackEffects.value as |attackEffect aID|}}
                            <span class="tag-legacy"><button class="npc-attackEffect" data-attackEffect="{{aID}}" data-action="npcAttackEffect">Plus {{attackEffect}}</button></span>
                        {{/each}}
                    {{/if_all}}
                    {{#if_all item.data item.data.attackEffects item.data.attackEffects.custom}}
                        <span class="tag-legacy"><button class="npc-attackEffect" data-attackEffect="{{aID}}" data-action="npcAttackEffect">Plus {{item.data.attackEffects.custom}}</button></span>
                    {{/if_all}}
                </div>
            </div>
        </li>
        {{/each}}
      {{/each}}
    </ol>

    <ol class="actions-list inventory-list directory-list item-list">
      {{#each actor.reorgActions.offensive.actions as |section sid|}}
        {{#each section.actions as |action aid|}}
        <li class="list-row item action-item" data-item-name="{{action.name}}" data-item-id="{{action._id}}">
            <div class="item-name rollable">
                <div class="item-image" style="background-image: url({{action.img}})"></div>
                <h4>{{action.name}}</h4>
                <div class="melee-buttons">
                  {{#if action.traits}}
                    {{#each action.traits as |trait tid|}}
                      {{#if trait.description}}
                        <span class="tag-legacy" title="{{localize trait.description}}" style="padding: 0 3px;">{{localize trait.label}}</span>
                      {{else}}
                        <span class="tag-legacy" style="padding: 0 3px;">{{localize trait.label}}</span>
                      {{/if}}
                    {{/each}}
                  {{/if}}
                </div>
            </div>
        </li>
        {{/each}}
     {{/each}}
    </ol>

    <ol class="inventory-list toggles-list item-list">
      <li class="action-header">
        <h3 class="pf-heading pf-actions">Toggles (Experimental)</h3>
      </li>
      <li class="actions-options item-list">
        {{#each data.toggles.actions as |toggle idx|}}
        <div class="actions-option item" data-toggle-property="{{toggle.inputName}}" data-toggle-label="{{localize toggle.label}}">
          <label>
            <input type="checkbox" name="{{toggle.inputName}}" {{checked toggle.checked}}>
            <span>{{localize toggle.label}}</span>
          </label>
        </div>
        {{/each}}
      </li>
    </ol>

    <ol class="actions-list inventory-list directory-list strikes-list item-list">
      <li class="list-row action-header">
        <h3 class="pf-heading pf-actions">{{localize 'PF2E.StrikesLabel'}} (Experimental)</h3>
      </li>
      {{#each actor.data.actions as |action ai|}}
      <li class="list-row item expandable" data-action-index="{{ai}}">
        <div class="melee-name rollable">
          <div class="item-image" style="background-image: url({{action.imageUrl}})"></div>
          <h4>
            {{localize action.attackRollType}}
            <span class="strike">{{action.name}} <span class="activity-icon">{{action.glyph}}</span></span>
          </h4>
          <div class="melee-buttons">
            {{#each action.traits as |trait ti|}}
            <span class="tag-legacy" style="padding: 0 3px;">{{localize trait.label}}</span>
            {{/each}}
            {{#each action.variants as |variant vi|}}
            <span class="tag-legacy"><button type="button" class="tag-legacy variant-strike" {{#if (eq vi 0) }}title="{{action.breakdown}}"{{/if}} data-variant-index="{{vi}}">{{variant.label}}</button></span>
            {{/each}}
            <span class="tag-legacy"><button type="button" class="tag-legacy damage-strike">{{localize 'Damage'}}</button></span>
            <span class="tag-legacy"><button type="button" class="tag-legacy critical-strike">{{localize 'Critical'}}</button></span>
          </div>
        </div>
      </li>
      {{/each}}
    </ol>

    {{#if hasSpells}}
    {{#each spellcastingEntries as |entry eid|}}
    <hr>
    <div class="stats-line">
      <span class="inline-stats">
          <label class="stat-title">{{{entry.name}}}</label>
          <span class="stat-value" title="{{entry.data.dc.breakdown}}">{{localize "PF2E.DCLabel"}} {{entry.data.dc.value}}</span>
          <span class="stat-detail speed" title="{{entry.data.attack.breakdown}}">{{localize "PF2E.AttackLabel"}} {{numberFormat entry.data.attack.value decimals=0 sign=true}}</span>
      </span>
    </div>

    <ol class="actions-list inventory-list directory-list item-list">
        <!-- List Spells -->
        {{#each entry.levels as |section lvl|}}
            {{#if section.active.length}}
                <li class="list-row inventory-header sub-category spellbook-header">
                    <div class="item-name flexrow">
                        <h3 style="background-color: var(--alternate-background);">{{localize section.label}}</h3>
                    </div>
                </li>

                {{#each section.active as |item i|}}
                    {{#with item}}
                    <li class="list-row item" data-item-id="{{spell.id}}" data-entry-id="{{entry.id}}" data-spell-lvl="{{section.level}}" data-slot-id="{{i}}" data-expended-state="{{item.expended}}">
                        <div class="item-name rollable">
                            <div class="item-image" style="background-image: url({{chatData.img}})"></div>
                            {{#if expended}}
                                <h4 style="text-decoration: line-through">{{spell.name}}</h4>
                            {{else}}
                                <h4>{{spell.name}}</h4>
                            {{/if}}
                        </div>

                        <div class="melee-buttons spell-buttons">
                            {{#each chatData.traits as |trait tid|}}
                                {{#if trait.description}}
                                <span class="tag-legacy" title="{{localize trait.description}}" style="padding: 0 3px;">{{localize trait.label}}</span>
                                {{else}}
                                <span class="tag-legacy" style="padding: 0 3px;">{{localize trait.label}}</span>
                                {{/if}}
                            {{/each}}

                            {{#if chatData.isSave}}
                            <span class="tag-legacy">{{localize "PF2E.SaveDCLabel"}} {{chatData.save.dc}} {{chatData.save.basic}} {{localize chatData.save.str}}</span>
                            {{/if}}
                            {{#if chatData.isAttack}}
                            <span class="tag-legacy"><button data-action="spellAttack" title="{{entry.data.attack.breakdown}}">{{localize "PF2E.AttackLabel"}} {{numberFormat entry.data.attack.value decimals=0 sign=true}}</button></span>
                            {{/if}}
                            {{#if chatData.hasDamage}}
                            <span class="tag-legacy"><button data-action="spellDamage">{{chatData.damageLabel}}: {{chatData.damage.value}}</button></span>
                            {{/if}}
                        </div>

                        {{#if ../../../owner}}
                        <div class="item-controls">
                            <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                            {{#if entry.isPrepared}}
                                {{#unless section.isCantrip}}
                                    <a class="item-control item-unprepare" title="{{localize "PF2E.UnprepareItemTitle"}}"><i class="fas fa-minus-square"></i></a>
                                {{/unless}}
                            {{else}}
                                <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>
                            {{/if}}
                        </div>
                        {{/if}}
                    </li>
                    {{/with}}
                {{/each}}
            {{/if}}
        {{/each}}
    </ol>
    <hr>
    {{/each}}
    {{/if}}

    </div>
    <div class="bgcontainer" style="background-image: url('{{actor.img}}')"></div>
</form>
